# $Id: 21-create_split_fastq_files.t 12818 2011-03-16 12:53:22Z ajb $
use strict;
use warnings;
use Carp;
use English qw{-no_match_vars};
use Test::More tests => 4;
use Test::Exception;
use lib qw{t};
use t::util;
use File::Slurp;

BEGIN {
  use_ok(q{npg_pipeline::archive::file::generation::touchSplitFiles});
}

my $util = t::util->new();

my $runfolder_path = $util->analysis_runfolder_path();
my @temp = split m{/}xms, $runfolder_path;
my $runfolder = pop @temp;

$ENV{TEST_USERAGENT} = $runfolder_path . q{/useragent};

{
  $util->set_rta_staging_analysis_area( 1 );
  write_file( $ENV{TEST_USERAGENT}, $util->serialized_useragent() );

  `cp t/barcodes/sanger.tags $runfolder_path/lane_1.tag`;
  `cp t/barcodes/sanger.tags $runfolder_path/lane_7.tag`;

  my $object;
  lives_ok {
    $object = npg_pipeline::archive::file::generation::touchSplitFiles->new({
      run_folder => $runfolder,
      verbose => 1,
      runfolder_path => $runfolder_path,
    });
  } q{object created ok};
  isa_ok( $object, q{npg_pipeline::archive::file::generation::touchSplitFiles}, q{$object} );

  lives_ok {
    $object->generate();
  }
}
1;