# $Id: 21-references_adapters.t 12818 2011-03-16 12:53:22Z ajb $
use strict;
use warnings;
use Carp;
use English qw{-no_match_vars};
use Test::More tests => 8;
use Test::Exception;
use lib q{t};
use t::util;

BEGIN {
  use_ok( q{npg_pipeline::pre_exec::references_adapters} );
}

my $conf_path = t::util->new()->conf_path();

{

  my $ref_adapt;
  throws_ok {
    $ref_adapt = npg_pipeline::pre_exec::references_adapters->new(ref_repository => q{t/data/sequence/refs});
  } qr{Attribute[ ][(]ref_repository[)][ ]does[ ]not[ ]pass[ ]the[ ]type[ ]constraint}, q{object creation failed as reference not found};

}

{

  my $ref_adapt;
  lives_ok {
    $ref_adapt = npg_pipeline::pre_exec::references_adapters->new({
      ref_repository => q{t/data/sequence/references},
      conf_path => $conf_path,
      domain => q{test},
    });
  } q{create object ok};
  isa_ok( $ref_adapt, q{npg_pipeline::pre_exec::references_adapters}, q{$ref_adapt} );

  ok( $ref_adapt->check_existence(), q{references and adapters directories found} );

  is( $ref_adapt->ref_adapter_pre_exec_string(), q{-E 't/bin/software/solexa/bin/npg_pipeline_preexec_references --ref_repository t/data/sequence/references'}, q{correct ref_adapter_pre_exec_string} );

}

{

  my $return = qx{bin/npg_pipeline_preexec_references --ref_repository t/data/sequence/refs};
  ok( $CHILD_ERROR, qq{failed as could not locate references directory - $CHILD_ERROR} );

}

{
  my $return = qx{bin/npg_pipeline_preexec_references --ref_repository t/data/sequence/references};
  ok( ! $CHILD_ERROR, q{script ran OK} );
}
1;